The BOOST_PP_SEQ_FOLD_LEFT macro folds (or accumulates) the elements of a seq left-to-right.

#### Usage

BOOST_PP_SEQ_FOLD_LEFT(op, state, seq)

#### Arguments

op
  A ternary operation of the form op(s, state, elem). This macro is called for each element in seq--each time returning a new state. This operation is expanded by BOOST_PP_SEQ_FOLD_LEFT with the next available fold step, the current state, and the current element.
state
  The initial state of the fold.
seq
  The seq to be folded.

#### Remarks

For the seq, (0)(1)(2), this macro expands to:
op(s, op(s, op(s, state, 0), 1), 2)
For maximum efficiency, BOOST_PP_SEQ_FOLD_LEFT can be reentered with BOOST_PP_SEQ_FOLD_LEFT_s.

#### See Also

- BOOST_PP_SEQ_FOLD_LEFT_s

#### Requirements

Header: <boost/preprocessor/seq/fold_left.hpp>

#### Sample Code

    #include <boost/preprocessor/cat.hpp>
    #include <boost/preprocessor/seq/fold_left.hpp>

    #define SEQ (b)(o)(o)(s)(t)

    #define OP(s, state, x) BOOST_PP_CAT(state, x)

    BOOST_PP_SEQ_FOLD_LEFT(OP, BOOST_PP_SEQ_HEAD(SEQ), BOOST_PP_SEQ_TAIL(SEQ)) // expands to boost